// ResOnlyDLLaw.cpp : implementation file
//

#include "stdafx.h"
#include "ResOnlyDLL.h"
#include "ResOnlyDLLaw.h"

#include <comdef.h>

#ifdef _PSEUDO_DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// This is called immediately after the custom AppWizard is loaded.  Initialize
//  the state of the custom AppWizard here.
void CResOnlyDLLAppWiz::InitCustomAppWiz()
{
	// There are no steps in this custom AppWizard.
	SetNumberOfSteps(0);

	// Add build step to .hpj if there is one
	m_Dictionary[_T("HELP")] = _T("1");

	// Inform AppWizard that we're making a DLL.
	m_Dictionary[_T("PROJTYPE_DLL")] = _T("1");

	// TODO: Add any other custom AppWizard-wide initialization here.
}

// This is called just before the custom AppWizard is unloaded.
void CResOnlyDLLAppWiz::ExitCustomAppWiz()
{
	// TODO: Add code here to deallocate resources used by the custom AppWizard
}

// This is called when the user clicks "Create..." on the New Project dialog
CAppWizStepDlg* CResOnlyDLLAppWiz::Next(CAppWizStepDlg* pDlg)
{
	ASSERT(pDlg == NULL);	// By default, this custom AppWizard has no steps

	// Set template macros based on the project name entered by the user.

	// Get value of $$root$$ (already set by AppWizard)
	CString strRoot;
	m_Dictionary.Lookup(_T("root"), strRoot);
	
	// Set value of $$Doc$$, $$DOC$$
	CString strDoc = strRoot.Left(6);
	m_Dictionary[_T("Doc")] = strDoc;
	strDoc.MakeUpper();
	m_Dictionary[_T("DOC")] = strDoc;

	// Set value of $$MAC_TYPE$$
	strRoot = strRoot.Left(4);
	int nLen = strRoot.GetLength();
	if (strRoot.GetLength() < 4)
	{
		CString strPad(_T(' '), 4 - nLen);
		strRoot += strPad;
	}
	strRoot.MakeUpper();
	m_Dictionary[_T("MAC_TYPE")] = strRoot;

	// Return NULL to indicate there are no more steps.  (In this case, there are
	//  no steps at all.)
	return NULL;
}

void CResOnlyDLLAppWiz::CustomizeProject(IBuildProject* pProject)
{
	// TODO: Add code here to customize the project.  If you don't wish
	//  to customize project, you may remove this virtual override.

	try
	{
		IConfigurations * pConfs = NULL;
		IConfiguration * pConf = NULL;
		HRESULT hr = pProject->get_Configurations( &pConfs );
		if (FAILED(hr))
			throw _T("get_Configurations()");
		ASSERT(pConfs);
		COleVariant vt;
		long lCount = 0;
		hr = pConfs->get_Count( &lCount );
		if (FAILED(hr))
			throw _T("get_Count()");
		for (long l = 1L; l <= lCount; l++)
		{
			COleVariant vtItem( l );
			hr = pConfs->Item( vtItem, &pConf );
			if (FAILED(hr))
				throw _T("Item()");

			ASSERT(pConf);

			hr = pConf->AddToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/incremental:no") ), vt );
			if (FAILED(hr))
				throw _T("AddToolSettings()");

			hr = pConf->RemoveToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/implib") ), vt );
			if (FAILED(hr))
				throw _T("RemoveToolSettings()");

			hr = pConf->AddToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/pdb:none") ), vt );
			if (FAILED(hr))
				throw _T("AddToolSettings()");

			hr = pConf->AddToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/nodefaultlib") ), vt );
			if (FAILED(hr))
				throw _T("AddToolSettings()");

			hr = pConf->RemoveToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/debug") ), vt );
			if (FAILED(hr))
				throw _T("RemoveToolSettings()");

			hr = pConf->AddToolSettings( _bstr_t( _T("link.exe") ),
				_bstr_t( _T("/noentry") ), vt );
			if (FAILED(hr))
				throw _T("AddToolSettings()");

			pConf->Release();
			pConf = NULL;
		}
	}
	catch (LPCTSTR psz)
	{
		::MessageBox( ::AfxGetMainWnd()->GetSafeHwnd(),
			psz, _T("Error"), MB_OK | MB_ICONSTOP );
	}
	
	// This is called immediately after the default Debug and Release
	//  configurations have been created for each platform.  You may customize
	//  existing configurations on this project by using the methods
	//  of IBuildProject and IConfiguration such as AddToolSettings,
	//  RemoveToolSettings, and AddCustomBuildStep. These are documented in
	//  the Developer Studio object model documentation.

	// WARNING!!  IBuildProject and all interfaces you can get from it are OLE
	//  COM interfaces.  You must be careful to release all new interfaces
	//  you acquire.  In accordance with the standard rules of COM, you must
	//  NOT release pProject, unless you explicitly AddRef it, since pProject
	//  is passed as an "in" parameter to this function.  See the documentation
	//  on CCustomAppWiz::CustomizeProject for more information.
}


// Here we define one instance of the CResOnlyDLLAppWiz class.  You can access
//  m_Dictionary and any other public members of this class through the
//  global ResOnlyDLLaw.
CResOnlyDLLAppWiz ResOnlyDLLaw;

